#include "mcc_generated_files/mcc.h"

#define PERIOD_MAX    200  //PWM
#define CYCLE_MIN       5
#define CYCLE_MAX      24
#define CYCLE_DEG      18
#define TIME_UP 0
#define TIME_OFF -1
#define SERVO_WAIT    200

uint16_t duty_cycle;
uint16_t period_cnt;
uint8_t move;
int16_t timwait;

void tmr0Servo(void);
void ServoWrite(uint8_t deg);

/* Main application */
void main(void)
{
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(tmr0Servo);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();

    while (1)
    {
        switch(move){
            case 0:
                if( timwait == TIME_UP ){
                    ServoWrite(0);
                    timwait = SERVO_WAIT;
                    move = 1;
                }
                break;
            case 1:
                if( timwait == TIME_UP ){
                    ServoWrite(9);
                    timwait = SERVO_WAIT;
                    move = 2;
                }
                break;
            case 2:
                if( timwait == TIME_UP ){
                    ServoWrite(14);
                    timwait = SERVO_WAIT;
                    move = 0;
                }      
                break;
        }
    }
}

/* PWMg`𐶐i荞݃R[obNj */
void tmr0Servo(void){
    
    if( duty_cycle < CYCLE_MIN){
        duty_cycle = CYCLE_MIN;
    }
    
    if( duty_cycle > CYCLE_MAX){
        duty_cycle = CYCLE_MAX;
    }
    
    if( period_cnt >= duty_cycle){
         IO_RB3_SetLow();
    }
    
    if(++period_cnt >= PERIOD_MAX ){
        period_cnt = 0;
        IO_RB3_SetHigh();
    }
    
    if( period_cnt == 0 || period_cnt == PERIOD_MAX/2){
        if( timwait > TIME_UP ){
            timwait--;
        }
    }
}
/* T[{[^[̉]w߁i0-18 1:10x 18:180xj */
void ServoWrite(uint8_t deg){

    if( deg > CYCLE_DEG){
        deg = CYCLE_DEG;
    }    

    duty_cycle = deg + CYCLE_MIN;
}
/**
 End of File
*/